<template>
	<view class="container">
		<cu-custom bgColor="bg-gradual-pink" :isBack="true">
			<block slot="backText">返回</block>
			<block slot="content">出库确认</block>
		</cu-custom>
		<view class="example">
			<uni-forms ref="form" :model="formData" labelWidth="80px">
				<uni-forms-item label="托盘编号" name="palletCode">
					<view class="flex-twice  padding-0 radius">
						<uni-easyinput v-model="formData.palletCode" placeholder="请输入托盘编号" @blur="queryPalletInfo" />
					</view>
					<view class="flex-sub padding-0 margin-xs radius">
						<view class="cu-capsule radius" v-if="palletInfo.needPickQty>0">
							<view class='cu-tag bg-blue '>
								需拣选数量{{palletInfo.needPickQty}}
							</view>
						</view>
					</view>
					<!-- </view> -->
				</uni-forms-item>
				<!-- 	<uni-forms-item label="拣选数量" name="pickQty">
						<view class="flex-twice  padding-0 radius">
							<uni-easyinput v-model="formData.pickQty" placeholder="请输入拣选数量" @blur="queryPalletInfo" />
						</view>
				</uni-forms-item> -->
			</uni-forms>
			<button type="primary" @click="formSubmit">提交</button>
			<!-- <!--明细 -->
			<view v-if='palletInfo.details.length>0'>
				<view class="uni-container">
					<uni-table ref="table" :loading="loading" border stripe type="selection" emptyText="暂无更多数据"
						@selection-change="selectionChange">
						<uni-tr>
							<uni-th width="280" align="center">基本信息</uni-th>
							<uni-th width="100" align="center">设置</uni-th>
						</uni-tr>
						<uni-tr v-for="(item, index) in palletInfo.details" :key="index">
							<uni-td>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">托盘编号</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.palletCode}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">物料编号</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.skuCode}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">物料名称</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.skuName}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">物料类型</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.skuType}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">批次号</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.batch}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">分配数量</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.allotQty}}
										<view class='cu-tag bg-blue justify-end'>
											{{item.baseUnit}}
										</view>
									</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius ">已拣选</view>
									<view class="flex-twice padding-0 margin-xs radius">
										{{item.pickedQty}}
										<view class='justify-start cu-tag bg-blue'>
											{{item.baseUnit}}
										</view>
									</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">本次拣选</view>
									<view class="flex-twice padding-0 margin-xs radius">
										<uni-easyinput v-model="item.pickQty" placeholder="请输入拣选数量"
											@onBlur="pickQtyChange" @onInput="pickQtyChange" />
										<!-- <input placeholder="请输入拣选数量"  onBlur  onInput
											v-model="item.pickQty" @change="pickQtyChange"></input> -->
									</view>
								</view>
							</uni-td>

							<uni-td>
								<view class="grid  text-center solid-bottom  justify-start">
									<has-authority :code="'pallet:infoQuery:btn'">
										<view class=" margin-xs radius">
											<button class="uni-button" size="mini" type="primary"
												@click="btnModify">修改</button>
										</view>
									</has-authority>
									<has-authority :code="'pallet:infoQuery:btnAA'">
										<view class=" margin-xs radius">
											<button class="uni-button" size="mini" type="warn">删除</button>
										</view>
									</has-authority>
								</view>
							</uni-td>
							</uni-td>
						</uni-tr>
					</uni-table>
					<view class="uni-pagination-box"><uni-pagination show-icon :page-size="pageSize"
							:current="pageCurrent" :total="total" @change="change" /></view>
				</view>
			</view>
		</view>

		<view class="cu-modal" :class="msgModalName=='Modal'?'show':''">
			<view class="cu-dialog">
				<view class="cu-bar bg-white justify-end">
					<view class="content">{{msgTitleName}}</view>
					<view class="action" @tap="hideMsgModal">
						<text class="cuIcon-close text-red"></text>
					</view>
				</view>
				<view class="padding-xl">
					{{msg}}
				</view>
			</view>
		</view>
	</view>

</template>

<script>
	import appGlobal from '../../Global.vue'
	import {
		queryConfirmOutPallet,
		confirmOut
	} from "@/api/wms/outConfirm.js"
	import {
		formateDate
	} from 'tough-cookie'
	export default {
		data() {
			return {
				msg: "消息",
				msgModalName: "msgModalName",
				msgTitleName: "msgTitleName",
				//表单中的数据信息	
				formData: {
					palletCode: "",
					pickQty: 0,
					//details: []
				},
				rules: {
					palletCode: {
						rules: [{
							required: true,
							errorMessage: '托盘编号不能为空'
						}]
					},
					pickQty: {
						rules: [{
							required: true,
							errorMessage: '拣选数量不能为空'
						}]
					}
				},
				//查询获取的托盘信息
				palletInfo: {
					palletCode:'',
					pallet:{},
					needPickQty: 0,
					details: []
				},

				//table 相关
				searchVal: '',
				tableData: [],
				// 每页数据量
				pageSize: 10,
				// 当前页
				pageCurrent: 1,
				// 数据总量
				total: 0,
				loading: false,
				//tabe选中的数据对象
				selectedIndexs: [],
				// 列配置
				tableClumns: [],

				skuArray: [],
				skushow: false,
			};
		},
		onReady() {
			this.$refs.form.setRules(this.rules)
		},
		methods: {
			//数据来源[模拟]
			async fetch(param) {
				var response = await queryConfirmOutPallet(param);
				return {
					total: response.data.total,
					data: response.data.record,
				};
			},
			// 多选处理
			selectedItems() {
				return this.selectedIndexs.map(i => this.tableData[i])
			},
			// 多选
			selectionChange(e) {
				console.log(e.detail.index)
				this.selectedIndexs = e.detail.index
				//选中内容改变时获取选中数据

			},
			//批量删除
			delTable() {
				console.log(this.selectedItems())
			},
			// 分页触发
			change(e) {
				this.$refs.table.clearSelection()
				this.selectedIndexs.length = 0
				this.getData(e.current)
			},
			// 搜索
			search() {
				this.getData(1, this.searchVal)
			},
			// 获取数据
			getData(pageCurrent, value = '') {
				this.loading = true
				this.pageCurrent = pageCurrent
				this.request({
					pageSize: this.pageSize,
					pageCurrent: pageCurrent,
					value: value,
					success: res => {
						// console.log('data', res);
						this.tableData = res.data
						this.total = res.total
						this.loading = false
					}
				})
			},
			//获取选中的数据
			getSelectDetail() {
				if (this.selectedIndexs.length == 0) {
					//提示 
					this.$modal.msgError("请选择需要拣选的托盘明细")
					return;
				}
				//筛选出需要拣选的托盘号
				let arr = [];
				let len = this.palletInfo.details.length;
				for (let i = 0; i < len; i++) {
					if (this.selectedIndexs.indexOf(i) >= 0) {
						arr.push(this.palletInfo.details[i]);
					} else {
						// console.log(this.selectArr.indexOf(i))
						//this.selectArr.indexOf(i);
					}
				}
				console.log("输入的托盘编号为", arr.length)
				return arr;
			},

			// 伪request请求
			request(options) {
				const {
					pageSize,
					pageCurrent,
					success,
					value
				} = options
				let total = tableData.length
				let data = tableData.filter((item, index) => {
					const idx = index - (pageCurrent - 1) * pageSize
					return idx < pageSize && idx >= 0
				})
				if (value) {
					data = []
					tableData.forEach(item => {
						if (item.name.indexOf(value) !== -1) {
							data.push(item)
						}
					})
					total = data.length
				}

				setTimeout(() => {
					typeof success === 'function' &&
						success({
							data: data,
							total: total
						})
				}, 500)
			},
			// submit(ref) {
			// 	this.$refs.form.validate().then(res => {
			// 		updateUserProfile(this.user).then(response => {
			// 			this.$modal.msgSuccess("修改成功")
			// 		})
			// 	})
			// }
			pickQtyChange: function(e) {
				console.log("pickQtyChange", e)
			},
			//表单提交
			 formSubmit: function(ref) {
			        //拿到 formaData
			        //必须又明细被选中
			        var details = this.getSelectDetail()
			        console.log("details", details)
			        if (details && details.length > 0) {
			          this.$refs.form.validate().then(res => {
			            console.log("数据校验通过", res)
			            //this.formData.details = details
			            //  组织拣选数据
			            let pickDetails = []
						let checkOver = true;
			            var pickInfo = details.map((item,index) => {
			              console.log("item",item)
			              console.log("item",item)
			              let {palletCode, id, pickQty } = item
			              if(pickQty==undefined||pickQty> item.allotQty- item.pickedQty){
			                //弹窗报错index
			                this.$modal.msgError(`第${index+1}条明细数据异常，实际拣选数量应该小于或等于剩余未拣选数量` )
							checkOver = false;
			                return;
			                console.log("跳出循环")
			              }else{
			                pickDetails.push({
			                  palletCode: palletCode,
			                  pickId: id,
			                  pickQty: pickQty
			                })
			              }
			            })
			            console.log("pickDetails", pickDetails)
			            if(checkOver){
							console.log("校验通过")
							confirmOut(pickDetails).then(response => {
							 console.log("response", response)
							 this.$modal.msgSuccess("拣选成功").then(()=>{
								 console.log("Todo 刷新界面")
							 })
							})
						}
			          })
			        }

			},

			hideMsgModal(e) {
				//关闭信息模态框
				this.msgModalName = null;
			},
			textareaAInput(e) {
				this.textareaAValue = e.detail.value
			},
			textareaBInput(e) {
				this.textareaBValue = e.detail.value
			},
			//查询指定托盘上需拣选的信息
			queryPalletInfo: async function(e) {
				console.log('进入查询方法', e);
				console.log('this.formData', this.formData);
				console.log('this.formData.palletCode', this.formData.palletCode);
				var palletCode = this.formData.palletCode;
				if (palletCode == null) {
					this.$modal.msgError("托盘编号不能为空")
					return;
				}
				if (palletCode.length < 1) {
					this.$modal.msgError("托盘编号不能为空")
					return;
				}
				//查询单据信息
				var palletInfo = await queryConfirmOutPallet({
					'palletCode': palletCode
				}).then((res) => {
					console.log("res", res)
					const {data,msg,success} = res
					if (success) {
						this.palletInfo = data
						let detailList = this.palletInfo.details.map(item => {
							item.pickQty = item.allotQty - item.pickedQty;
						})	
							
					}

				});



			}
		}
	}
</script>



<style lang="scss">
	.cu-form-group .title {
		min-width: calc(4em + 15px);
	}

	page {
		background-color: #ffffff;
	}

	.example {
		padding: 15px;
		background-color: #fff;
	}

	.segmented-control {
		margin-bottom: 15px;
	}

	.button-group {
		margin-top: 15px;
		display: flex;
		justify-content: space-around;
	}

	.form-item {
		display: flex;
		align-items: center;
		flex: 1;
	}

	.button {
		display: flex;
		align-items: center;
		height: 35px;
		line-height: 35px;
		margin-left: 10px;
	}
</style>